unit Wait;
//   WaitBegin:TWaitForm;
//: MyMessage:String -  
//           MyCaption:PChar=nil -  
//           wfOptions:TwfOptions=[wfCancelButton,wfAnimate,wfProgressbar,wfDefaultLabel]
//             wfCancelButton -   
//             wfAnimate      -  
//             wfProgressbar  -  
//             wfDefaultLabel -   
//    StayOnTop  
// 
//    TWaitForm, :
//
//procedure WaitEnd -   
//
//function GetProgressInfo:TProgressInfo -    : Min, Max, Position
//
//procedure SetProgressBounds(Min:Integer=0;Max:Integer=100) -  Min  Max  
//
//procedure SetProgressPos(Position:Integer=0) -  Position  
//
//procedure IncProgressPos(Value:Integer=1) -  Position 
//
//procedure DecProgressPos(Value:Integer=1) -  Position 
//
//procedure PlayAnimate -  
//
//procedure StopAnimate -  
//
//procedure DisableCancelButton -   
//
//procedure EnableCancelButton -   
//
//procedure BlinkMessage -  
//
//procedure SetWaitLabelText(Text:String) -   ;
//
//procedure SetWaitFormCoordinate(X,Y:Integer) -   
//           ;
//
//procedure SetWaitFormPosition(FormPosition:TwfPosition) - 
//             FormPosition:
//          wfpTopLeft      -    
//          wfpTopRight     -    
//          wfpBottomLeft   -    
//          wfpBottomRight  -    
//          wfpCenterTop    -   
//          wfpCenterBottom -   
//          wfpCenterLeft   -   
//          wfpCenterRight  -   
//          wfpCenter       -  
//
//  Aborted,  ,     
//
//
//WForm:=WaitBegin('Message',PChar('Caption'),[wfProgressBar,wfCancelButton]);
//try
//  WForm.SetProgressBounds(0,50);
//  WForm.SetProgressPos(0);
//  for i:=1 to WForm.GetProgressInfo.Max do
//  begin
//    sleep(100);
//    Label1.Caption:=IntToStr(i);
//    WForm.SetProgressPos(i);
//    Label2.Caption:=IntToStr(WForm.GetProgressInfo.Position);
//    if WForm.Aborted then Break;
//  end;
//finally
//  WForm.WaitEnd;
//end;
interface
//****************************************
uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus;
//****************************************
const
  MESSAGE_FIRST_COLOR_INDEX=0;
  MESSAGE_LAST_COLOR_INDEX=1;
  MESSAGE_COLOR_SEQUENCE:array [MESSAGE_FIRST_COLOR_INDEX..MESSAGE_LAST_COLOR_INDEX]
        of TColor=(clWindowText, clInfoBk);
//**********************************
type
  TwfOption=(wfCancelButton,wfAnimate,wfProgressBar,wfDefaultLabel);
  TwfOptions=Set of TwfOption;
  TwfPosition=(wfpTopLeft,wfpTopRight,wfpBottomLeft,wfpBottomRight,
               wfpCenterTop,wfpCenterBottom,wfpCenterLeft,wfpCenterRight,
               wfpCenter);
  TProgressInfo=Record
    Min:Integer;
    Max:Integer;
    Position:Integer;
  end;
  TWaitForm = class(TForm)
    WaitLabel: TLabel;
    WaitAnimate: TAnimate;
    CancelButton: TButton;
    WaitProgressBar: TProgressBar;
    StaticLabel: TLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private declarations }
    FActive:TForm;
    FAborted: Boolean;
    procedure SetAborted(const Value: Boolean);
    procedure SetSizes;
  public
    { Public declarations }
    property Aborted:Boolean read FAborted write SetAborted;
    procedure WaitEnd;
    function GetProgressInfo:TProgressInfo;
    procedure SetProgressBounds(Min:Integer=0;Max:Integer=100);
    procedure SetProgressPos(Position:Integer=0);
    procedure IncProgressPos(Value:Integer=1);
    procedure DecProgressPos(Value:Integer=1);
    procedure PlayAnimate;
    procedure StopAnimate;
    procedure DisableCancelButton;
    procedure EnableCancelButton;
    procedure BlinkMessage;
    procedure SetWaitLabelText(Text:String);
    procedure SetWaitFormCoordinate(X,Y:Integer);
    procedure SetWaitFormPosition(FormPosition:TwfPosition);
  end;
//****************************************
function WaitBegin(MyMessage:String;
                   MyCaption:String='';
                   wfOptions:TwfOptions=[wfCancelButton,wfAnimate,wfProgressBar,wfDefaultLabel]): TWaitForm;
//****************************************
implementation
//****************************************
{$R *.DFM}
//****************************************
procedure TWaitForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=VK_F4) and (ssAlt in Shift)
  then Key:=0;
end;
//****************************************
function WaitBegin(MyMessage:String;
                     MyCaption:String='';
                     wfOptions:TwfOptions=[wfCancelButton,wfAnimate,wfProgressbar,wfDefaultLabel]): TWaitForm;
const
  DeltaX=20;
  DeltaY=20;
  ButtonDeltaY=5;
var
  i:Integer;
  MyFActive:TForm;
begin
  MyFActive:=Screen.ActiveForm;
  Result:=TWaitForm.Create(Application);
  with Result do
  begin
    FAborted:=False;
    FActive:=MyFActive;
    // wfOptions
    if wfCancelButton in wfOptions
    then CancelButton.Visible:=True
      else CancelButton.Height:=0;
    //
    if wfAnimate in wfOptions then begin
                                     WaitAnimate.Visible:=True;
                                     WaitAnimate.Active:=True;
                                   end
      else WaitAnimate.Height:=0;
    //
    if wfProgressBar in wfOptions then WaitProgressBar.Visible:=True
      else WaitProgressBar.Height:=0;
    //
    if wfDefaultLabel in wfOptions then StaticLabel.Visible:=True
      else StaticLabel.Height:=0;
    //
    with Controls[0] as TLabel do
        begin
          Caption:=MyMessage;
        end;
    if MyCaption<>''
    then
      Caption:=MyCaption
    else
      begin
       Caption:=Application.Title;
       if Assigned(FActive) then
       //Caption:=Caption+' ('+Application.MainForm.Caption+')';
       Caption:=Caption+' ('+FActive.Caption+')';
      end;
    //
    SetSizes;
    //
    Show;
    //Application.ProcessMessages;
    Refresh;
  end;
  for i:=0 to Screen.FormCount-1  do
  begin
    if Screen.Forms[i]<>Result
    then
      Screen.Forms[i].Enabled:=False;
  end;
end;
//****************************************
procedure TWaitForm.CancelButtonClick(Sender: TObject);
begin
  if MessageBox(Handle,' ?',PChar(Application.Title),
                MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2)=IDYES
  then FAborted:=True;
end;
//****************************************
procedure TWaitForm.DecProgressPos(Value: Integer);
begin
  SetProgressPos(WaitProgressBar.Position-1)
end;
//****************************************
function TWaitForm.GetProgressInfo: TProgressInfo;
begin
  Result.Min:=WaitProgressBar.Min;
  Result.Max:=WaitProgressBar.Max;
  Result.Position:=WaitProgressBar.Position;
end;
//****************************************
procedure TWaitForm.IncProgressPos(Value: Integer);
begin
  SetProgressPos(WaitProgressBar.Position+1)
end;
//****************************************
procedure TWaitForm.SetProgressBounds(Min, Max: Integer);
begin
  WaitProgressBar.Min:=Min;
  WaitProgressBar.Max:=Max;
  //Application.ProcessMessages;
end;
//****************************************
procedure TWaitForm.SetProgressPos(Position: Integer);
begin
  WaitProgressBar.Position:=Position;
  //Refresh;
end;
//****************************************
procedure TWaitForm.PlayAnimate;
begin
  WaitAnimate.Active:=True;
end;
//****************************************
procedure TWaitForm.StopAnimate;
begin
  WaitAnimate.Active:=False;
end;
//****************************************
procedure TWaitForm.WaitEnd;
var
  i:Integer;
begin
  if not Assigned(Self) then Exit;
  for i:=0 to Screen.FormCount-1  do
  begin
    Screen.Forms[i].Enabled:=True;
    if Screen.Forms[i]=FActive then
      if FActive.Visible then
      begin
        FActive.SetFocus;
        SetForeGroundWindow(FActive.Handle);
      end;
  end;
  {with Self as TWaitForm do
    if Assigned(FActive) and (FActive.Enabled) and (FActive.Visible) then
    begin
      FActive.SetFocus;
      SetForeGroundWindow(FActive.Handle);
    end;}
  Free;
end;
//****************************************
procedure TWaitForm.SetAborted(const Value: Boolean);
begin
  FAborted := Value;
end;
//****************************************
procedure TWaitForm.DisableCancelButton;
begin
  CancelButton.Enabled:=False;
end;
//****************************************
procedure TWaitForm.EnableCancelButton;
begin
  CancelButton.Enabled:=True;
end;
//****************************************
procedure TWaitForm.BlinkMessage;
var
  CurrColor:TColor;
  ColorIndex:Integer;
  i:Integer;
begin
  with WaitLabel.Font do
  begin
    CurrColor:=Color;
    ColorIndex:=MESSAGE_FIRST_COLOR_INDEX-1;
    for i:=MESSAGE_FIRST_COLOR_INDEX to MESSAGE_LAST_COLOR_INDEX do
    begin
      if CurrColor=MESSAGE_COLOR_SEQUENCE[i] then
      begin
        ColorIndex:=i;
        Break;
      end;
    end;
    if ColorIndex=MESSAGE_FIRST_COLOR_INDEX-1 then
    raise Exception.Create('   ');
    if ColorIndex=MESSAGE_LAST_COLOR_INDEX then ColorIndex:=MESSAGE_FIRST_COLOR_INDEX
    else Inc(ColorIndex,1);
    Color:=MESSAGE_COLOR_SEQUENCE[ColorIndex];
  end
end;
//**********************************
procedure TWaitForm.SetWaitLabelText(Text: String);
begin
  WaitLabel.Caption:=Text;
  SetSizes;
end;
//********************
procedure TWaitForm.SetSizes;
const
  DeltaX=20;
  DeltaY=20;
  ButtonDeltaY=5;
  Separators=['+',','];
var
  TempString:String;
  MessageText:String;
  MTextLength:Integer;
  i:Integer;
begin
  TempString:='';
  MessageText:=WaitLabel.Caption;
  MTextLength:=Length(MessageText);
  for i:=1 to MTextLength do
  begin
    TempString:=TempString+MessageText[i];
    if MessageText[i] in Separators then TempString:=TempString+' ';
  end;
  WaitLabel.Caption:=TempString;
  //
  if WaitLabel.Width+DeltaX>=(Screen.Width shr 1) then
  begin
    WaitLabel.Width:=(Screen.Width shr 1)-DeltaX;
    WaitLabel.WordWrap:=True;
    if WaitLabel.Width+DeltaX>(Screen.Width shr 1) then
    begin
      WaitLabel.WordWrap:=False;
      WaitLabel.Width:=(Screen.Width shr 1)-DeltaX;
    end;
  end;
  //
  if WaitLabel.Width+DeltaX>=StaticLabel.Width then
  begin
    WaitLabel.Left:=(DeltaX div 2);
    ClientWidth:=WaitLabel.Width+DeltaX;
  end
  else begin
    WaitLabel.Left:=(ClientWidth-WaitLabel.Width) shr 1;
  end;
  //
  WaitLabel.Top:=(DeltaY div 2);
  WaitLabel.Font.Color:=MESSAGE_COLOR_SEQUENCE[MESSAGE_FIRST_COLOR_INDEX];
  WaitAnimate.Top:=WaitLabel.Top+WaitLabel.Height+(DeltaY div 2);
  WaitProgressBar.Top:=WaitAnimate.Top+WaitAnimate.Height;
  if CancelButton.Visible then
  begin
    CancelButton.Top:=WaitProgressBar.Top+WaitProgressBar.Height+ButtonDeltaY;
    StaticLabel.Top:=CancelButton.Top+CancelButton.Height+ButtonDeltaY;
  end
  else begin
    StaticLabel.Top:=WaitProgressBar.Top+WaitProgressBar.Height;
  end;
  //
  ClientHeight:=StaticLabel.Top+StaticLabel.Height;
  //Refresh;
end;
//********************
procedure TWaitForm.SetWaitFormCoordinate(X, Y: Integer);
begin
  Top:=Y;
  Left:=X;
end;
//************************
procedure TWaitForm.SetWaitFormPosition(FormPosition:TwfPosition);
var
  MaxX:Integer;
  MaxY:Integer;
begin
  //wfpCenter
  if FormPosition=wfpCenter then
  begin
    Position:=poScreenCenter;
    Exit;
  end;
  //  
  MaxX:=Screen.Width;
  //MaxY:=Screen.Height;
  MaxY:=GetSystemMetrics(SM_CYFULLSCREEN);
  //
  //wfpTopLeft
  if FormPosition=wfpTopLeft then
    SetWaitFormCoordinate(0,0);
  //wfpTopRight
  if FormPosition=wfpTopRight then
    SetWaitFormCoordinate(MaxX-Width,0);
  //wfpBottomLeft
  if FormPosition=wfpBottomLeft then
    SetWaitFormCoordinate(0,MaxY-Height);
  //wfpBottomRight
  if FormPosition=wfpBottomRight then
    SetWaitFormCoordinate(MaxX-Width,MaxY-Height);
  //
  //wfpCenterTop
  if FormPosition=wfpCenterTop then
    SetWaitFormCoordinate((MaxX-Width) div 2,0);
  //wfpCenterBottom
  if FormPosition=wfpCenterBottom then
    SetWaitFormCoordinate((MaxX-Width) div 2,MaxY-Height);
  //wfpCenterLeft
  if FormPosition=wfpCenterLeft then
    SetWaitFormCoordinate(0,(MaxY-Height) div 2);
  //wfpCenterRight
  if FormPosition=wfpCenterRight then
    SetWaitFormCoordinate(MaxX-Width,(MaxY-Height) div 2);
end;
//************************
end.
